/*
 *  Name: opsv6snf.c  [SNiFf]
 *  Date: Mon Aug 12 15:10:19 2001
 *  Author: uLiX [uLiX@gmx.it]
 *
 *  thnx to all my friends... That's all folk: No More Is Ash...
 *
 *  Tested on: DEBiAN GNU/LiNUX (Woody) kernel 2.4.5 on a i586
 */

/*** completamente work in progress... salvata alla peggio per una ***
 *** decente presentazione... mailatemi a <uLiX@gmx.it> thanx ;)   ***/

#include "hdrsnf.h"
#include "pcksnf.h"
#include "opsv6snf.h"

void hop_show (const u_char *hdr, int dUMP)
{	
	/*** struttura in netinet/ip6.h > hop-by-hop header		 
		struct ip6_hbh
			{
				uint8_t  ip6h_nxt;
				uint8_t  ip6h_len;
			}; 								
	 ***/
	
	hbh = (struct ip6_hbh *)hdr;
	if (dUMP)
		fprintf(log, "[HOP>by>HOP]\n");
	if (!dUMP)
		fprintf(stdout, "[HOP>by>HOP]\n");
}

void dst_show (const u_char *hdr, int dUMP)
{
	/*** struttura in netinet/ip6.h > destination options header 
	 	struct ip6_dest
			{
				uint8_t  ip6d_nxt;
				uint8_t  ip6d_len;
			};
	***/
		
	dst = (struct ip6_dst *)hdr;
	if (dUMP)
		fprintf(log, "[DEST>OPS]\n");
	if (!dUMP)
		fprintf(stdout, "[DEST>OPS]\n");
}

void frag_show (const u_char *hdr, int dUMP)
{
	/*** struttura in netinet/ip6.h > fragment header
		struct ip6_frag
			{
				uint8_t   ip6f_nxt;
				uint8_t   ip6f_reserved;
				uint16_t  ip6f_offlg;
				uint32_t  ip6f_ident;
			};
	***/
		
	frg = (struct ip6_frag *)hdr;
	
	if (dUMP)
		fprintf(log, 
		"[fRAG]  iDENT: 0x%08x  OfflAG: 0x%x  RESERVed:  0x%x  fRAGlEN: %d\n",
			ntohl(frg->ip6f_ident), ntohs(frg->ip6f_offlg & IP6F_OFF_MASK),
					frg->ip6f_reserved, sizeof(struct ip6_frag));
	if (!dUMP)
		fprintf(stdout,
		"[fRAG]  iDENT: 0x%08x  OfflAG: 0x%x  RESERVed:  0x%x  fRAGlEN: %d\n",            ntohl(frg->ip6f_ident), ntohs(frg->ip6f_offlg & IP6F_OFF_MASK),
					frg->ip6f_reserved, sizeof(struct ip6_frag));
}

void route_show (const u_char *hdr, int dUMP, int hOST)
{
	/*** struttura in netinet/ip6.h > routing header	
		struct ip6_rthdr
			{
				uint8_t  ip6r_nxt;
				uint8_t  ip6r_len;
				uint8_t  ip6r_type;
				uint8_t  ip6r_segleft;
			};
	***/
	/*** struttura in netinet/ip6.h > type 0 routing header
		struct ip6_rthdr0
			{
		      	uint8_t  ip6r0_nxt;
		    	uint8_t  ip6r0_len;
			    uint8_t  ip6r0_type;
			    uint8_t  ip6r0_segleft;
			    uint8_t  ip6r0_reserved;
			    uint8_t  ip6r0_slmap[3];
			    struct in6_addr  ip6r0_addr[1]; 
			};
	***/
		
	rthdr = (struct ip6_rthdr *)hdr;
	len = rthdr->ip6r_len;
	
	if (dUMP) {		
		fprintf(log, "[ROUTiNG] lEN: %d  ", rthdr->ip6r_len);
    	fprintf(log, "tYPE: %d  ", rthdr->ip6r_type);
		fprintf(log, "SEGlEft: %d  ", rthdr->ip6r_segleft);

		switch (rthdr->ip6r_type) {
				case IPV6_RTHDR_TYPE_0:
						rthdr0 = (struct ip6_rthdr0 *)hdr;
						fprintf(log, "RSV: 0x%0x  ",
										ntohl(rthdr0->ip6r0_reserved));
                		if (len % 2 == 1)
						goto trunc;
						len >>= 1;
						addr = &rthdr0->ip6r0_addr[0];
						for (i = 0; i < len; i++) {
							/*if ((u_char *)(addr + 1) > ep)
							goto trunc;*/
							if (hOST)	
								fprintf(log, "[%d] %s", 
											i, resolve_src((char *)addr));
							if (!hOST)
								fprintf(log, "[%d] %s", 
											i, resolve_src((char *)addr));
							addr++;
						}
						break;
				default:
						goto trunc;														       			break;
		}	
	}
	if (!dUMP) {
		fprintf(stdout, "[ROUTiNG] lEN: %d  ", rthdr->ip6r_len);
		fprintf(stdout, "tYPE: %d  ", rthdr->ip6r_type);
		fprintf(stdout, "SEGLEFt: %d  ", rthdr->ip6r_segleft);

		switch (rthdr->ip6r_type) {
				case IPV6_RTHDR_TYPE_0:
						rthdr0 = (struct ip6_rthdr0 *)hdr;
						fprintf(stdout, "RSV: 0x%0x  ",
										ntohl(rthdr0->ip6r0_reserved));
						if (len % 2 == 1)
				        	goto trunc;
		                len >>= 1;
						addr = &rthdr0->ip6r0_addr[0];
						for (i = 0; i < len; i++) {
					  		/*if ((u_char *)(addr + 1) > ep)
								goto trunc;*/
							if (hOST)
								fprintf(stdout, "[%d] %s", 
											i, resolve_src((char *)addr));
							if (!hOST)
					          	fprintf(stdout, "[%d] %s", 
											i, resolve_src((char *)addr));
						addr++;
		           		}
			            break;
		          default:
			               goto trunc;
					       break;
		}
	}
	trunc:
		fprintf(stdout, "[|ROUTiNG]");
}
	
void nope_show (const u_char *hdr, int dUMP)
{	
	if (dUMP)
		fprintf(log, "[NO NXT HEADER...]\n");
	if (!dUMP)
		fprintf(stdout, "[NO NXT HEADER...]\n");
}
/*	
void encap_show (const u_char *hdr, int dUMP)
{
    //return (0);
}
*/
