/*
 *  Name: tcpsnf.h  [SNiFf]
 *  Date: Mon Aug 12 15:10:19 2001
 *  Author: uLiX [uLiX@gmx.it]
 *
 *  thnx to all my friends... That's all folk: No More Is Ash...
 *
 *  Tested on: DEBiAN GNU/LiNUX (Woody) kernel 2.4.5 on a i586
 */

/*** define per le optioni tcp ancora non implementate ***
#ifndef TCPOPT_WSCALE
#define TCPOPT_WSCALE    3
#endif

#ifndef TCPOPT_SACKOK
#define TCPOPT_SACKOK    4
#endif

#ifndef TCPOPT_SACK
#define TCPOPT_SACK      5
#endif

#ifndef TCPOPT_ECHO
#define TCPOPT_ECHO		 6
#endif

#ifndef TCPOPT_ECHOREPLY
#define TCPOPT_ECHOREPLY 7
#endif

#ifndef TCPOPT_TIMESTAMP
#define TCPOPT_TIMESTAMP 8
#endif

#ifndef TCPOPT_CC
#define TCPOPT_CC		11
#endif

#ifndef TCPOPT_CCNEW
#define TCPOPT_CCNEW	12
#endif

#ifndef TCPOPT_CCECHO
#define TCPOPT_CCECHO	13
#endif

#ifndef TH_ECNECHO
#define TH_ECNECHO		0x40
#endif

#ifndef TH_CWR
#define TH_CWR			0x80
#endif
*** define per le optioni tcp ancora non implementate ***/

#define TCP_HDR_LEN		hdr.len - sizeof(struct ip) \
							+ sizeof(struct tcphdr) + offset

#define HDRLEN  		(ip->ip_hl & 0x0f) * 4
#define TCPHLEN			(u_int16_t)(tcp->doff << 2)
							
struct  tcphdr	*tcp;
struct  ip      *ip;

u_char  *saddr_ipv4;
u_char  *daddr_ipv4;

char    src_ipv4[INET_ADDRSTRLEN];
char    dst_ipv4[INET_ADDRSTRLEN];

int		hlen;
int     len;
int		tos;
int     id;
int     frag;
int     ttl;

u_int sport, dport;
u_int16_t window, t_hlen;
u_int32_t seq, ack_seq;
