/*
 *  Name: icmpsnf.h  [SNiFf]
 *  Date: Mon Aug 12 15:10:19 2001
 *  Author: uLiX [uLiX@gmx.it]
 *
 *  thnx to all my friends... That's all folk: No More Is Ash...
 *
 *  Tested on: DEBiAN GNU/LiNUX (Woody) kernel 2.4.5 on a i586
 */

#define HDRLEN          (ip->ip_hl & 0x0f) * 4
#define ICMP_HDR_LEN    hdr.len - sizeof(struct ip) \
										+ sizeof(struct icmp) + offset

struct icmp *icmp;
struct ip   *ip;

u_char  *saddr_ipv4;
u_char  *daddr_ipv4;

char    src_ipv4[INET_ADDRSTRLEN];
char    dst_ipv4[INET_ADDRSTRLEN];

int     hlen;
int     len;
int     tos;
int     id;
int     frag;
int     ttl;
