/*
 *  Name: mainsnf.c  [SNiFf]
 *  Date: Mon Aug 12 13:15:55 2001
 *  Author: uLiX [uLiX@gmx.it]
 *
 *  thnx to all my friends... That's all folk: No More Is Ash...
 *
 *  Tested on: DEBiAN GNU/LiNUX (Woody) kernel 2.4.5 on a i586
 */

#include "hdrsnf.h"

int main (int argc, char **argv)
{	
	char  *r_name;		/*** nome reale del prog ***/
	
	int vERB, dATA, pROM, pROTo, eXt, dUMP, NaME, oPS; 
	vERB = dATA = pROM = pROTo = eXt = dUMP = NaME = 0;
  
	
  	if (geteuid() != 0) {
    	printf ("\e[1;31m\nanD uiD/eUId(0)? s0Rry...\e[0m\n\n");
    	exit (0);
  	}
  	
  	if ((r_name = strrchr(argv[0], '/')) != NULL)
		p_name = r_name + 1;
  	else
  		p_name = argv[0];

  	while ((oPS = getopt(argc, argv, "hvdxlpNi:cgtu")) != EOF) {

    	switch(oPS) {
				case 'h':
						usage();
	       				break;
      			case 'v':
      	       			vERB++;
	       				break;
      			case 'd':
		       			dATA++;
	       				break;
      			case 'x':
               			eXt++;
	       				break;
      			case 'l':
               			dUMP++;
	       				break;				     
	      		case 'p':
				       	pROM++;
	       				break;
	  			case 'N':
						NaME++;
						break;
      			case 'i':
	    			   	name_face = optarg; 
			       		break;
      			case 'c':
	       			   	pROTo++;
			       		break;
      			case 'g': 
	       			   	pROTo += 2;
			       		break;
      			case 't': 
	        		   	pROTo += 3;
			       		break;
	      		case 'u': 
			           	pROTo += 4;
	       				break;
	      		default:
						printf("\e[1;31m\nPRoVA %s -h...\n\n\e[0m", p_name);
	      				exit(0);
			          	break;
		}
  	}

  	signal(SIGKILL, pcap_device_off);
  	signal(SIGQUIT, pcap_device_off);
  	signal(SIGTERM, pcap_device_off);
  	signal(SIGINT,  pcap_device_off);
  
  	if (dUMP) mkdir(DIRE, 0600);
  	
  	pcap_device_on(pROM, vERB, dATA, pROTo, eXt, dUMP, NaME);
  	return (0);	
}

void usage()
{
 	printf("\n\e[1;31muSO:");
  	printf("  \e[1;34m[\e[1;31m-h\e[1;34m] \e[1;34m[\e[1;31m-v\e[1;34m] \e[1;34m[\e[1;31m-d\e[1;34m] \e[1;34m[\e[1;31m-x\e[1;34m] \e[1;34m[\e[1;31m-l\e[1;34m] \e[1;34m[\e[1;31m-p\e[1;34m] \e[1;34m[\e[1;31m-N\e[1;34m] \e[1;34m[\e[1;31m-i interfaccia\e[1;34m]   \e[1;34m[\e[1;31m-c\e[1;34m] \e[1;34m[\e[1;31m-g\e[1;34m] \e[1;34m[\e[1;31m-t\e[1;34m] \e[1;34m[\e[1;31m-u\e[1;34m]\e[0m\n");        
  	printf("\e[1;34m\n");
  	printf("\t-h\t\tuso\n");
  	printf("\t-v\t\tverbose mode\n");
  	printf("\t-d\t\tlogga i dati in formato ascii semplice\n");
  	printf("\t-x\t\tlogga i dati in formato ascii/hex\n");
  	printf("\t-l\t\tsalva in diversi file .log\n");
  	printf("\t-p\t\tsetta la modalita' promiscua\n");
	printf("\t-N\t\trisolve ip\n");
  	printf("\t-i\t\tinterfaccia per la cattura dei pacchetti\n");
  	printf("\t-c\t\tlogga solo pacchetti icmp/icmpv6\n");
  	printf("\t-g\t\tlogga solo pacchetti igmp\n");
  	printf("\t-t\t\tlogga solo pacchetti tcp\n");
  	printf("\t-u\t\tlogga solo pacchetti udp\n");
  	printf("\e[0m\n");
          
  	exit(0);
}
