/*
 *  Name: pcksnf.h  [SNiFf]
 *  Date: Mon Aug 12 15:10:19 2001
 *  Author: uLiX [uLiX@gmx.it]
 *
 *  thnx to all my friends... That's all folk: No More Is Ash...
 *
 *  Tested on: DEBiAN GNU/LiNUX (Woody) kernel 2.4.5 on a i586
 */

#ifndef IPPROTO_IPV4
#define IPPROTO_IPV4    4   // ridefinito a 4 per l'header hop-by-hop (0)...
#endif

#ifndef IPOPT_SECURITY
#define IPOPT_SECURITY	130
#endif

#ifndef IPOPT_RA
#define IPOPT_RA		148
#endif

#define VERSION	(ip->ip_v)
#define HDRLEN	(ip->ip_hl & 0x0f) * 4

#define IPV4    4
#define IPV6    6

#define	CLASS	0x0ff00000
#define	FLOW2	0x000fffff
#define PRI		0x0f000000
#define FLOW1	0x00ffffff

struct  ip		*ip;
struct  ip6_hdr	*ip6;

const 	u_char *cpy_hdr;
int		nxt_hdr;
int	  	nxt_prt;

u_char	*saddr_ipv6;
u_char	*daddr_ipv6;
u_char	*saddr_ipv4;
u_char	*daddr_ipv4;

char    src_ipv6[INET6_ADDRSTRLEN];
char    dst_ipv6[INET6_ADDRSTRLEN];
char    src_ipv4[INET_ADDRSTRLEN];
char    dst_ipv4[INET_ADDRSTRLEN];

char 	*option;

int     prty;
int 	flow;
int		plen;
int 	hlim;

int 	ttl;
int 	hlen;

unsigned int hdr_len;
int 	len;
int		tos;
int 	id;
int 	frag;
int 	opts;
