/*
 *  Name: tcpv6snf.h  [SNiFf]
 *  Date: Mon Aug 12 15:10:19 2001
 *  Author: uLiX [uLiX@gmx.it]
 *
 *  thnx to all my friends... That's all folk: No More Is Ash...
 *
 *  Tested on: DEBiAN GNU/LiNUX (Woody) kernel 2.4.5 on a i586
 */

/*** define per le optioni tcp ancora non implementate ***
#ifndef TCPOPT_WSCALE
#define TCPOPT_WSCALE    3
#endif

#ifndef TCPOPT_SACKOK
#define TCPOPT_SACKOK    4
#endif

#ifndef TCPOPT_SACK
#define TCPOPT_SACK      5
#endif

#ifndef TCPOPT_ECHO
#define TCPOPT_ECHO		 6
#endif

#ifndef TCPOPT_ECHOREPLY
#define TCPOPT_ECHOREPLY 7
#endif

#ifndef TCPOPT_TIMESTAMP
#define TCPOPT_TIMESTAMP 8
#endif

#ifndef TCPOPT_CC
#define TCPOPT_CC		11
#endif

#ifndef TCPOPT_CCNEW
#define TCPOPT_CCNEW	12
#endif

#ifndef TCPOPT_CCECHO
#define TCPOPT_CCECHO	13
#endif

#ifndef TH_ECNECHO
#define TH_ECNECHO		0x40
#endif

#ifndef TH_CWR
#define TH_CWR			0x80
#endif
*** define per le optioni tcp ancora non implementate ***/

#define CLASS   0x0ff00000
#define FLOW2   0x000fffff
#define PRI     0x0f000000
#define FLOW1   0x00ffffff

#define TCP6_HDR_LEN		hdr.len - sizeof(struct ip6_hdr) \
								+ sizeof(struct tcphdr) + offset

							
struct  tcphdr	*tcp;
struct  ip6_hdr	*ip6;

u_char  *saddr_ipv6;
u_char  *daddr_ipv6;

char    src_ipv6[INET6_ADDRSTRLEN];
char    dst_ipv6[INET6_ADDRSTRLEN];

int     prty;
int     flow;
int     plen;
int     hlim;

u_int sport, dport;
u_int16_t window;
u_int32_t seq, ack_seq;
