/*
 *  Name: udpsnf.c  [SNiFf]
 *  Date: Mon Aug 12 13:17:38 2001
 *  Author: uLiX [uLiX@gmx.it]
 *
 *  thnx to all my friends... That's all folk: No More Is Ash...
 *
 *  Tested on: DEBiAN GNU/LiNUX (Woody) kernel 2.4.5 on a i586
 */

#include "hdrsnf.h"
#include "utlssnf.h"
#include "udpsnf.h"

void udp_show (int v, int d, int x, int dUMP, int h) 
{
	tmp = time(NULL);
	strftime(datora, 60, "%T"/*[%D]"*/, localtime(&tmp));
/*** questa %T stampa il tempo al completo... aggiunta con C99 ***/

	udp = (struct udphdr *)(info_buf + sizeof(struct ip) + offset);
	ip  = (struct ip *)(info_buf + offset);

	data_info = NULL;       /*** puntatore azzerato (?) ***/
	data_info = (char *)(info_buf + sizeof(struct ip) + sizeof(struct udphdr)
											                    + offset);

	hlen    =   HDRLEN;
	len     =   ntohs(ip->ip_len);
	tos     =   ip->ip_tos;
	id      =   ip->ip_id;
	frag    =   ntohs(ip->ip_off);
	ttl     =   ip->ip_ttl;

	saddr_ipv4 = (unsigned char *)inet_ntop(AF_INET, &ip->ip_src.s_addr,
													src_ipv4, sizeof(src_ipv4));    daddr_ipv4 = (unsigned char *)inet_ntop(AF_INET, &ip->ip_dst.s_addr,
													dst_ipv4, sizeof(dst_ipv4));

	sport   =   ntohs(udp->source);
	dport   =   ntohs(udp->dest);
	udp_len	=	udp->len;
	check	=	udp->check;
													
	if (dUMP) {

    	snprintf (name, sizeof(name), "%suDP.lOg", DIRE);
    	log = fopen (name, "a");
    	
		if (!h)
			fprintf(log, "\n\n[IPv4] %s  fROM: %s:%d >> tO: %s:%d\n   ",
						datora, saddr_ipv4, sport, daddr_ipv4, dport);
		if (h)
			fprintf(log, "\n\n[IPv4] %s %s|%s >> %s|%s\n   ",
				datora, resolve_src(src_ipv4), resolve_port_src(sport),
					resolve_dst(dst_ipv4), resolve_port_dst(dport));
		fprintf(log, "    lENGTH: %d  tOS: 0x%X  iD: %d  tTL: %d  ",
													len, tos, id, ttl);
		if (v) {
			if (frag & IP_RF)
				fprintf(log, "fRAG: RF (0x%x)  ", frag);
			else if (frag & IP_DF)
				fprintf(log, "fRAG: DF (0x%x)  ", frag);
			else if (frag & IP_MF)
				fprintf(log, "fRAG: MF (0x%x)  ", frag);
			else fprintf(log, "fRAG: 0x%x  ", frag);
		}
		
		if ((hlen -= sizeof(struct ip)) > 0) {
			fprintf(log, "OPtlEN: %d  ", hlen);
			ippg_ops_show((u_char *)ip, hlen, log);
		}
		else fprintf(log, "\n");
		
		fprintf (log, "[UDP]  hDR lENGTH: 0x%x  Ck_SUM 0x%x", udp_len, check);

		if (d)
			data_sniffo(data_info, UDP_HDR_LEN, log);
		if (x)
			print_ascii_hex(data_info, UDP_HDR_LEN, log);

		fclose (log);
	}					
												
	if (!dUMP) {
    	
		if (!h)
			fprintf(stdout, "\n\n[IPv4] %s  fROM: %s:%d >> tO: %s:%d\n   ",
						datora, saddr_ipv4, sport, daddr_ipv4, dport);
		if (h)
			fprintf(stdout, "\n\n[IPv4] %s %s|%s >> %s|%s\n   ",
				datora, resolve_src(src_ipv4), resolve_port_src(sport),
					resolve_dst(dst_ipv4), resolve_port_dst(dport));
		fprintf(stdout, "    lENGTH: %d  tOS: 0x%X  iD: %d  tTL: %d  ",
													len, tos, id, ttl);
		if (v) {
			if (frag & IP_RF)
				fprintf(stdout, "fRAG: RF (0x%x)  ", frag);
			else if (frag & IP_DF)
				fprintf(stdout, "fRAG: DF (0x%x)  ", frag);
			else if (frag & IP_MF)
				fprintf(stdout, "fRAG: MF (0x%x)  ", frag);
			else fprintf(stdout, "fRAG: 0x%x  ", frag);
		}
		
		if ((hlen -= sizeof(struct ip)) > 0) {
			fprintf(stdout, "OPtlEN: %d  ", hlen);
			ippg_ops_show((u_char *)ip, hlen, stdout);
		}
		else fprintf(stdout, "\n");
		
		fprintf (stdout, "[UDP]  hDR lENGTH: 0x%x  Ck_SUM 0x%x", udp_len, check);

		if (d)
			data_sniffo(data_info, UDP_HDR_LEN, stdout);
		if (x)
			print_ascii_hex(data_info, UDP_HDR_LEN, stdout);
	}
}
