/*
 *  Name: udpsnf.h  [SNiFf]
 *  Date: Mon Aug 12 13:17:38 2001
 *  Author: uLiX [uLiX@gmx.it]
 *
 *  thnx to all my friends... That's all folk: No More Is Ash...
 *
 *  Tested on: DEBiAN GNU/LiNUX (Woody) kernel 2.4.5 on a i586
 */

#define UDP_HDR_LEN     hdr.len - sizeof(struct ip) \
                            + sizeof(struct udphdr) + offset

#define HDRLEN          (ip->ip_hl & 0x0f) * 4

struct  udphdr  *udp;
struct  ip      *ip;

u_char  *saddr_ipv4;
u_char  *daddr_ipv4;

char    src_ipv4[INET_ADDRSTRLEN];
char    dst_ipv4[INET_ADDRSTRLEN];

int     hlen;
int     len;
int     tos;
int     id;
int     frag;
int     ttl;

u_int sport, dport;
u_int16_t udp_len;
u_int16_t check;
