/*
 *  Name: udpv6snf.h  [SNiFf]
 *  Date: Mon Aug 12 15:10:19 2001
 *  Author: uLiX [uLiX@gmx.it]
 *
 *  thnx to all my friends... That's all folk: No More Is Ash...
 *
 *  Tested on: DEBiAN GNU/LiNUX (Woody) kernel 2.4.5 on a i586
 */

#define CLASS   0x0ff00000
#define FLOW2   0x000fffff
#define PRI     0x0f000000
#define FLOW1   0x00ffffff

#define UDP6_HDR_LEN     hdr.len - sizeof(struct ip6_hdr) \
                            	+ sizeof(struct udphdr) + offset

struct  udphdr  *udp;
struct  ip6_hdr *ip6;

u_char  *saddr_ipv6;
u_char  *daddr_ipv6;

char    src_ipv6[INET6_ADDRSTRLEN];
char    dst_ipv6[INET6_ADDRSTRLEN];

int     prty;
int     flow;
int     plen;
int     hlim;

u_int sport, dport;
u_int16_t udp_len;
u_int16_t check;
